/* autocontrol module for turbopkg - header file */

#define AUTOCONTROL_PORT 3050
#define AUTOCONTROL_MAX_CONNECTIONS 1
#define MAX_STRING_LENGTH 1024
#define MAX_INPUT_LENGTH 4096
#define PULSE_PER_SECOND	    4
#define CMD_ACCEPT 1
#define ACCESS_ACCEPTED 1

#define IS_VALID(data)          ((data) != NULL && (data)->valid)
#define VALIDATE(data) ((data)->valid = TRUE)
#define INVALIDATE(data) ((data)->valid = FALSE)
#define str_dup strdup
#define wlog logMessage
#define UMIN(a, b)              ((a) < (b) ? (a) : (b))
#define UMAX(a, b)              ((a) > (b) ? (a) : (b))


#define AUTO_ERR_SUPPORTFILES 1

#define AUTO_ERRFLAG_FATAL 1

typedef struct	descriptor_data		DESCRIPTOR_DATA;

struct	descriptor_data
{
    DESCRIPTOR_DATA *	next;
    bool		valid;
    char *		host;
    short int		descriptor;
    short int		connected;
    bool		fcommand;
    char		inbuf		[4 * MAX_INPUT_LENGTH];
    char		incomm		[MAX_INPUT_LENGTH];
    char		inlast		[MAX_INPUT_LENGTH];
    int			repeat;
    char *		outbuf;
    int			outsize;
    int			outtop;
    char *		showstr_head;
    char *		showstr_point;
    char **		pString;	/* for string editor */
    void *              pEdit;          /* OLC */
    int		 	editor;
    int command_mode;
    int access_flag;
};

/* prototypes */

int autoWelcome(short int);
int autoSuccess(short int mydesc);
int autoMessage(short int,char *);
int autoError(short int,int,int);
int autoErrorMsg(short int,char *,int);
#define autoErrMsg autoErrorMsg
int autoStatus(short int,char *, char *);
int autoStatusEnd(short int);

void init_descriptor(int,int);
void read_from_buffer(DESCRIPTOR_DATA *);
void close_socket(DESCRIPTOR_DATA *);
void free_descriptor(DESCRIPTOR_DATA *);
int init_socket(int,int, char *);
bool read_from_descriptor(DESCRIPTOR_DATA *);
bool write_to_descriptor(int,char *,int);
DESCRIPTOR_DATA *new_descriptor(void);

int autoMainHandler(int,char **);

