/* turbopkg - defines.h */

#include <rpm/rpmlib.h>
#include <errno.h>
#include "includes.h"

#ifndef VERSION
#define VERSION "unknown"
#endif

#ifndef VER_DATE
#define VER_DATE "unknown"
#endif

#ifdef INSTALLER
#define WITHOUT_AUTOCONTROL
#endif

#ifndef WITHOUT_AUTOCONTROL
#define AUTOCONTROL 1
#endif

#ifdef AUTOCONTROL
#define AUTOCONTROL_INI "/usr/lib/turbolinux/autocontrol.ini"
#define AUTOCONTROL_UNIXSOCK "/usr/lib/turbolinux/turbopkgsock"
#endif

/*
 * You must change both of the following two lines to change architectures.
 */
#define ARCHITECTURE "i386"
#define ARCH_PATH "/i386/"
#define ARCH ARCHITECTURE

#define PASSWDFILE "/etc/passwd"
#define CONFIGFILE "/etc/turbopkgrc"
#ifdef INSTALLER
#define INSTALLER_XPKGS_LIST "/mnt/tmp/xfns"
#endif

#define COMPSFILE_REQUIRED_VERSION "1TL"

#define INSTALLER_BINARY_DIR "/tmp/tlimage/bin"
#define INSTALLER_BINARY_DIR2 "/usr/bin"
#define DEFAULT_CD_MOUNTPOINT "/mnt/cdrom"
#define EJECT_CDROM 1

#define DEFAULT_BASEPATH "/mnt/cdrom"

#define CUSTOM_INDEX 8
#define CUSTOM_SELECTEDLIST "/tmp/custom-tmp"
#define CUSTOM_SELECTEDLIST_INSTALLER "/mnt/tmp/custom-tmp"

#define COMPSFILE "/mnt/cdrom/TurboLinux/base/comps"
#define COMPSFILE_ALT "/mnt/cdrom/TurboUpgrade/base/comps"
#define COMPSFILE_INSTALLER "/tmp/tlimage/TurboLinux/base/comps"
#define COMPSFILE_INSTALLER2 "/tmp/tlimage/turbolin/base/comps"
#define COMPSFILE_TESTING "comps"
#define COMPSFILE_FTP "/tmp/comps"
#define COMPSFILE_FTP_INSTALLER "/mnt/tmp/comps"

#define RPMSDIR "/mnt/cdrom/TurboLinux/RPMS"
#define RPMSDIR_ALT "/mnt/cdrom/TurboUpgrade/RPMS"
#define RPMSDIR_INSTALLER "/tmp/tlimage/TurboLinux/RPMS"
#define RPMSDIR_INSTALLER2 "/tmp/tlimage/turbolin/rpms"
#define RPMSDIR_INSTALLER3 "/tmp/tlimage/TurboLinux/rpms"
#define RPMSDIR_TESTING getenv("TPI_RPMS")
#define RPMSDIR_FTP "/tmp"
#define RPMSDIR_FTP_INSTALLER "/mnt/tmp"

#define HDLIST "/mnt/cdrom/TurboLinux/base/hdlist"
#define HDLIST_ALT "/mnt/cdrom/TurboUpgrade/base/hdlist"
#define HDLIST_INSTALLER "/tmp/tlimage/TurboLinux/base/hdlist"
#define HDLIST_INSTALLER2 "/tmp/tlimage/turbolin/base/hdlist"
#define HDLIST_TESTING getenv("TPI_HDLIST")
#define HDLIST_FTP "/tmp/hdlist"
#define HDLIST_FTP_INSTALLER "/mnt/tmp/hdlist"

#define CUSTOMLISTDIR_INSTALLER "/tmp/tlimage/customlists"
#define CUSTOMLISTDIR_INSTALLER_FLOPPY "/tmp/floppy/customlists"
#define CUSTOMLISTDIR_FLOPPY "/mnt/floppy/customlists"
#define CUSTOMLISTDIR_TESTING "./customlists"
#define CUSTOMLISTDIR_DEFAULT "/usr/lib/turbolinux/turbopkg/customlists"
#define MAX_LISTS 50

#define SKELETON_REMOTE_FN "/TurboLinux/base/skeleton.cgz"
#define SKELETON_LOCAL_FN "/mnt/tmp/skeleton.cgz"
#define SKELETON_CDROM_FN "/tmp/tlimage/TurboLinux/base/skeleton.cgz"
#define SKELETON_CDROM_FN2 "/tmp/tlimage/turbolin/base/skeleton.cgz"

#define FLOPPY_MNTPOINT_INSTALLER "/tmp/floppy"
#define FLOPPY_MNTPOINT "/mnt/floppy"

#define DEFAULT_RPM_FLAGS RPMINSTALL_REPLACEFILES | RPMINSTALL_REPLACEPKG | RPMINSTALL_NOARCH | RPMINSTALL_UPGRADE
#define RPM_FLAGS_KERNELMODULES RPMINSTALL_REPLACEFILES | RPMINSTALL_NOARCH
#define RPM_FLAGS_NOSCRIPTS DEFAULT_RPM_FLAGS | RPMINSTALL_NOSCRIPTS

#define DEFAULT_FTP_PORT 21
#define FTP_DEFAULT_PORT DEFAULT_FTP_PORT
#define FTP_CREATE_MODE 0644
#define FTPINSTALL_GET_XSERVERS 1

#define FILENAME_TAG 1000000
#define MAX_VERSION_FIELDS 10

#define SUCCESS 1
#define FAILURE 0
#define CANCELLED 2
#define FORCECANCEL 3

#ifdef MAINCODE
#define declare
#else
#define declare extern
#endif

