#include "defines.h"
#include "log.h"
#include "prototypes.h"

extern char *dumpfn;
extern int doSuggest;
extern int ignoreConflicts;

int dumpInfo(tlInstall *theInstall) {
	FILE *fp;
	installType *itPtr=NULL;
	tlComponentGroup *cPtr=NULL;
	int x=1;
	int cc=0;
	char **gPtr=NULL;
	int iSize=0;
	static int zz;
	
	fp=fopen(dumpfn,"w");
	if (!fp) return FAILURE;
	fprintf(fp,"TurboPkg v%s - Data Dump\n",VERSION);
	fprintf(fp,"----------------------------\n\n");	
	fprintf(fp,"Operating Language      : %s\n",theInstall->language);
	fprintf(fp,"Components File         : %s\n",theInstall->compsfile);
	fprintf(fp,"RPM Directory           : %s\n",theInstall->rpmdir);
	fprintf(fp,"HDLIST File             : %s\n",theInstall->hdlist);
	fprintf(fp,"Number of Install Types : %d\n",theInstall->numInstallTypes);
	fprintf(fp,"Install Type Selected   : %d\n",theInstall->itypeSelected);
	itPtr=theInstall->installTypes->next;
	while(itPtr) {
		fprintf(fp,"\t%d. '%s'\n",x,itPtr->name);
		cPtr=theInstall->masterComponentList->next;
		while (cPtr) {
			if (cPtr->installtypes[x-1] == '1') {
				fprintf(fp,"\t\t%s\n",cPtr->name);
			}
			cPtr=cPtr->next;
		}
		itPtr=itPtr->next;
		x++;
	}
	cPtr=theInstall->masterComponentList->next;
	while (cPtr) {
		cc++;
		cPtr=cPtr->next;
	}
	cPtr=theInstall->masterComponentList->next;
	fprintf(fp,"Total Component Groups  : %d\n",cc);
	while(cPtr) {
		fprintf(fp,"\t'%s' (%d pkgs, size %d)\n",cPtr->name,cPtr->packageSet.numPackages,cPtr->size);
		gPtr=cPtr->requires;
		while(*gPtr) {
			fprintf(fp,"\t\tRequires '%s'\n",*gPtr);
			gPtr++;
		}
		gPtr=cPtr->suggests;
		while(*gPtr) {
			fprintf(fp,"\t\tSuggests '%s'\n",*gPtr);
			gPtr++;
		}
		gPtr=cPtr->conflicts;
		while(*gPtr) {
			fprintf(fp,"\t\tConflicts with '%s'\n",*gPtr);
			gPtr++;
		}
		for (zz=0;zz < cPtr->packageSet.numPackages;zz++) {
			fprintf(fp,"\t\t%s\n",cPtr->packageSet.packages[zz]->name);
		}
		cPtr=cPtr->next;
	}
	fprintf(fp,"Installation Sizes (%s, %s):\n",doSuggest ? "with suggestions" : "without suggestions",ignoreConflicts ? "ignoring conflicts" : "honoring conflicts");
	itPtr=theInstall->installTypes->next;
	while(itPtr) {
		iSize=getInstallSize(itPtr,theInstall->masterComponentList,doSuggest,ignoreConflicts,theInstall->forcepackages,&theInstall->masterPackageSet);
		iSize = (iSize / (1024 * 1024));
		fprintf(fp,"\t%-30s : %d MB\n",itPtr->name,iSize);
		iSize=0;
		itPtr=itPtr->next;
	}
	fclose(fp);
	return SUCCESS;
}
