/*
#### Copyright (c) 1998 Pacific HiTech, Inc.
####              All Rights Reserved
####              Distributable under the terms of the GPL.
#### File:        ftp.h
#### Author:      Scott Stone <sstone@turbolinux.com>
#### Version:     1.0J
#### Date:        January 28, 1998
#### Description:
# Source code for TurboLinux
#### ChangeLog:
# (none)
*/

#ifndef H_FTP
#define H_FTP

const char * ftpStrerror(int ftpErrno);

#define FTPERR_BAD_SERVER_RESPONSE   -1
#define FTPERR_SERVER_IO_ERROR       -2
#define FTPERR_SERVER_TIMEOUT        -3
#define FTPERR_BAD_HOST_ADDR         -4
#define FTPERR_BAD_HOSTNAME          -5
#define FTPERR_FAILED_CONNECT        -6
#define FTPERR_FILE_IO_ERROR         -7
#define FTPERR_PASSIVE_ERROR         -8
#define FTPERR_FAILED_DATA_CONNECT   -9
#define FTPERR_FILE_NOT_FOUND        -10
#define FTPERR_UNKNOWN               -100
#define FTPERR_USER_CANCELLED        -200

int ftpOpen(char * host, char * name, char * password, char * proxy, int port);
int ftpGetFile(int sock, char * remotename, int dest, int displaystatus);
int ftpGetFileByName(int sock, char *remotename, char *localname, int displaystatus);
int ftpGetFileDesc(int sock, char * remotename, int *filesize);
int ftpGetFileDone(int sock);
void ftpClose(int sock);
const char *ftpStrerror(int);
int askFTP(ftpConfig *,int);
int getFTPPaths(ftpConfig *);
int getHDListByFTP(ftpConfig *f);
int getCompsByFTP(ftpConfig *f,tlInstall *i);

#endif
