#ifndef INCLUDES_H
#define INCLUDES_H

#include <linux/stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <newt.h>
#include <string.h>
#include <sys/ioctl.h>
#include <rpm/rpmlib.h>

#include "tlcomps.h"

#define TRUE  1
#define FALSE 0

typedef int bool;

/*   added for internationalization.   */
#include <locale.h>
#include <libintl.h>
#define _(String)  gettext(String)
#define N_(String)  gettext(String)
#define __(String) (String)

#define PACKAGE "turbopkg"
#define LOCALEDIR "/usr/lib/turbolinux/turbopkg/text/"
#define LOCALEDIR_INSTALLER "/etc/turbopkg/text"

typedef struct _tlInstall {
	int numInstallTypes;
	char *language;
	installType *installTypes;
	int itypeSelected;
	tlComponentGroup *masterComponentList;
	pkgSet masterPackageSet;
	pkgSet *selectedPackageSet;
	Header *installedPackages;
	char **ipkglist;
	char *compsfile;
	char *rpmdir;
	char *hdlist;
	char **forcepackages;
} tlInstall;

typedef struct _ftpMirror {
	struct _ftpMirror *next;
	char *location;
	char *hostname;
	char *directory;
} ftpMirror;

typedef struct _ftpConfig {
	char *language;
	char *ftphost;
	char *ftpdir;
	char *uftphost;
	char *uftpdir;
	char *proxy;
	char *username;
	char *password;
	int port;
	ftpMirror *mirrors;
	ftpMirror *umirrors;
} ftpConfig;

typedef struct _customList {
	char *name;
	char *pathname;
	char **packages;
} customList;

typedef struct _headerSizeCacheEntry {
	char *name;
	unsigned int size;
} headerSizeCacheEntry;
	

#endif /* INCLUDES_H */
