/* prototypes for turbopkg */


/* turbopkg.c */
tlInstall *initInstall(char *);
int readCompsFile(tlInstall *,char *);
void drawBackground(char *);

/* util.c */
void strchop(char *);
char *strcasestr(const char *, const char *);
int memberofStrArray(char **array, const char *element);
char *memberofStrArray2(char **array, const char *element);
int memberofStrArrayBySubstring(char **array, const char *element);
int memberofPkgSet(pkgSet *, char *);
int memberofComponentGroup(tlComponentGroup *grouplist, char *groupname);
int containsNonDigits(char *);
int parsePkgRCFile(ftpConfig *, char *,int);
int checkFreeSpace(int requiredkb, int *);
char **removeFromStrArray(char **array, char *element, int size);
int addToStrArray(char **array,char *element);
int basicStrCompare(const void * a, const void * b);
char **uniquifyStrArray(char **array, int sort);
char *pathExpandHomeDir(const char *thePath);
char *checkVersions(void);
char *getFilenameByPkgName(char *dirname, char *pkgname);

/* installtypes.c */
int initInstallTypes(tlInstall *);
pkgSet *prepareNormal(installType *,tlComponentGroup *, pkgSet *, pkgSet *, char **, Header *, char **);
pkgSet *prepareCustom(installType *,tlComponentGroup *, pkgSet *, pkgSet *, char **, Header *, char **);
pkgSet *prepareFromList(installType *,tlComponentGroup *, pkgSet *, pkgSet *, char **, Header *, char **);
int buildITypeCompList(tlInstall *);
int getInstallSize(installType *,tlComponentGroup *,int,int,char **,pkgSet *);
int getPkgSetSize(pkgSet *);
int getPkgSetSize2(pkgSet *, Header *);
int getPkgSetSizeInBytes(pkgSet *);
struct packageInfo *getPackageByName(pkgSet *, char *);
int freeComponentGroup(tlComponentGroup *);
int freePkgSet(pkgSet **ps);
int comparePackageInfo(void *xp1, void *xp2);
int getNumPackages(pkgSet *theSet, char **rlist);

/* parse_comps.c */
int addPackageToSet(pkgSet *theSet, char *pkgname, int priority, int flags, int selected);
int addPackageToSetByHeader(pkgSet *theSet, Header h, int priority, int flags, int selected);
int parseCompsFile(tlInstall *);

/* dumpinfo.c */
int dumpInfo(tlInstall *);

/* rpmfuncs.c */
int getPackageHeaders(char *, pkgSet *, int);
int getPackageHeaders2(char *, pkgSet *, pkgSet *);
int getPackageHeadersFromHDList(char *, pkgSet *);
tlComponentGroup *getGroupByName(tlComponentGroup *grouplist,char *gname);
int getGroupSize(tlComponentGroup *, tlComponentGroup *);
char **getRPMInfo(pkgSet *,const char *);
int verifyDependencies(pkgSet *, Header *, char **);
int getCurrentlyInstalled(tlInstall *);
int pkgVersionCompare(const char *, const char, const char *);
char isPackageInstalled(Header *, char **, pkgSet *, struct packageInfo *, char **);
tlComponentGroup *getRPMGroups(pkgSet *i);
int getPackageSetFromSystem(tlInstall *);
char **getRequires(pkgSet *pkgset,const char *pkgtext);
char **getProvides(pkgSet *pkgset,const char *pkgtext);
int extractPictureFromPackage(tlInstall *i, char *pkgname, char *outbasefn);

/* menus.c */
void doWelcomeScreen(void);
void doInstallerWelcomeScreen(void);
int doMainMenu(tlInstall *);
int doOptionsMenu(void);
void displayRPMInfo(char **,pkgSet *,char *);
int showUnresolvableDependencies(char **);
void helpWindow(char *title, int numPages, char **helpPages);
int loadLocationMenu(void);
char **chooseCustomList(customList *);

/* pkginstall.c */
int doInstall(tlInstall *,ftpConfig *);
int installSkeleton(ftpConfig *f);
int removeSelectedPackages(char **rlist);
int scanFilenames(char *dirname, fnBinding *fblist);
char *lookupFilename(fnBinding *fblist, char *packagename);

/* setupfs.c */
int askLocations(tlInstall *i, int comps, int rpms, int hdlist);
int getLocationsByBasePath(tlInstall *i, char *path);
int cdromMounted(void);
int askCDROM(void);
void unmountCDROM(void);
int mountFloppy(void);
int unmountFloppy(void);

/* ftp.c */
#include "ftp.h"
int ftpGetRPM(int sock, char *remotename, int dest, newtComponent *label, newtComponent *sizelabel, newtComponent *scale);
int getSkelByFTP(ftpConfig *f);
int ftpForceXServers(pkgSet *theSet);

/* autocontrol.c */
#include "autocontrol.h"
int autoParseCommand(DESCRIPTOR_DATA *d);
int autoLoadConfig(char *configfn, char **compsfilepath, char **rpmpath, char **hdlistpath, ftpConfig *ftpconf, int *isftp, int *nocompsfile, int *norpmdir, int *nohdlist);
